/**
 * Created with IntelliJ IDEA.
 * User: varadig
 * Date: 2013.10.18.
 * Time: 18:57
 * To change this template use File | Settings | File Templates.
 */
package {
import controler.GameControler;
import controler.ScreenControler;

import core.base.CoreBaseSprite;
import core.filesystem.CoreFileSystem;
import core.filesystem.CoreFileSystemMobile;
import core.logger.CoreLogger;
import core.logger.CoreLoggerConsol;
import core.notification.CoreNotificationContainer;

import flash.display.Loader;
import flash.display.StageAlign;
import flash.display.StageOrientation;
import flash.display.StageScaleMode;
import flash.events.Event;
import flash.filesystem.File;
import flash.filesystem.FileMode;
import flash.filesystem.FileStream;
import flash.geom.Rectangle;
import flash.system.Capabilities;
import flash.utils.ByteArray;

import mx.resources.ResourceManager;

import starling.core.Starling;

import view.ScreenContainer;

[ResourceBundle('opening')]
public class Main extends CoreBaseSprite {
    public function Main() {
        this.initContext();
        this.initCoreModules();
        this.initModules();
        this.startApplication();
    }

    private var starling:Starling;
    private var launchImage:Loader;
    private var savedAutoOrients:Boolean;

    private final function initContext():void {
        this.context.stage = this.stage;
    }

    private final function initCoreModules():void {
        CoreLogger.getInstance(new CoreLoggerConsol());
        CoreNotificationContainer.getInstance();
        CoreFileSystem.getInstance(new CoreFileSystemMobile());
    }

    private final function initModules():void {
        ScreenControler.getInstance();
        GameControler.getInstance();
    }

    private function startApplication():void {
        this.stage.align = StageAlign.TOP_LEFT;
        this.stage.scaleMode = StageScaleMode.NO_SCALE;
        this.mouseEnabled = this.mouseChildren = false;
        trace("START APPLICATION");
        // this.showLaunchImage();
        //this.stage.loaderInfo.addEventListener(Event.COMPLETE, loaderInfo_completeHandler);
        this.loaderInfo_completeHandler();

    }

    private function showLaunchImage():void {
        var filePath:String;
        var isPortraitOnly:Boolean = false;
        if (Capabilities.manufacturer.indexOf("iOS") >= 0) {
            if (Capabilities.screenResolutionX == 1536 && Capabilities.screenResolutionY == 2048) {
                var isCurrentlyPortrait:Boolean = this.stage.orientation == StageOrientation.DEFAULT || this.stage.orientation == StageOrientation.UPSIDE_DOWN;
                filePath = isCurrentlyPortrait ? "Default-Portrait@2x.png" : "Default-Landscape@2x.png";
            }
            else if (Capabilities.screenResolutionX == 768 && Capabilities.screenResolutionY == 1024) {
                isCurrentlyPortrait = this.stage.orientation == StageOrientation.DEFAULT || this.stage.orientation == StageOrientation.UPSIDE_DOWN;
                filePath = isCurrentlyPortrait ? "Default-Portrait.png" : "Default-Landscape.png";
            }
            else if (Capabilities.screenResolutionX == 640) {
                isPortraitOnly = true;
                if (Capabilities.screenResolutionY == 1136) {
                    filePath = "Default-568h@2x.png";
                }
                else {
                    filePath = "Default@2x.png";
                }
            }
            else if (Capabilities.screenResolutionX == 320) {
                isPortraitOnly = true;
                filePath = "Default.png";
            }
        }

        if (filePath) {
            var file:File = File.applicationDirectory.resolvePath(filePath);
            if (file.exists) {
                var bytes:ByteArray = new ByteArray();
                var stream:FileStream = new FileStream();
                stream.open(file, FileMode.READ);
                stream.readBytes(bytes, 0, stream.bytesAvailable);
                stream.close();
                this.launchImage = new Loader();
                this.launchImage.loadBytes(bytes);
                this.addChild(this.launchImage);
                this.savedAutoOrients = this.stage.autoOrients;
                this.stage.autoOrients = false;
                if (isPortraitOnly) {
                    this.stage.setOrientation(StageOrientation.DEFAULT);
                }
            }
        }
    }

    private function starling_rootCreatedHandler(event:Object):void {
        if (this.launchImage) {
            this.removeChild(this.launchImage);
            this.launchImage.unloadAndStop(true);
            this.launchImage = null;
            this.stage.autoOrients = this.savedAutoOrients;
        }
    }

    private function loaderInfo_completeHandler(event:Event = null):void {
        trace("LOADER COMPLETE");
        Starling.handleLostContext = true;
        Starling.multitouchEnabled = true;
        this.starling = new Starling(ScreenContainer, this.stage);
        this.starling.enableErrorChecking = false;
        this.starling.showStats = true;
        this.starling.start();
        if (this.launchImage) {
            this.starling.addEventListener("rootCreated", starling_rootCreatedHandler);
        }

        this.stage.addEventListener(Event.RESIZE, stage_resizeHandler, false, int.MAX_VALUE, true);
        this.stage.addEventListener(Event.DEACTIVATE, stage_deactivateHandler, false, 0, true);
    }

    private function stage_resizeHandler(event:Event):void {
        this.starling.stage.stageWidth = this.stage.stageWidth;
        this.starling.stage.stageHeight = this.stage.stageHeight;

        const viewPort:Rectangle = this.starling.viewPort;
        viewPort.width = this.stage.stageWidth;
        viewPort.height = this.stage.stageHeight;
        try {
            this.starling.viewPort = viewPort;
        }
        catch (error:Error) {
        }
    }

    private function stage_deactivateHandler(event:Event):void {
        this.starling.stop();
        this.stage.addEventListener(Event.ACTIVATE, stage_activateHandler, false, 0, true);
    }

    private function stage_activateHandler(event:Event):void {
        this.stage.removeEventListener(Event.ACTIVATE, stage_activateHandler);
        this.starling.start();
    }
}
}
